#!/usr/bin/lua

--[[
 Lua CGI script for the USB remote switch controller

 v0.1 by Stelios Mersinas (steliosm@steliosm.net)
 c2013, All Rights Reserved.


 This program is free software: you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation, either version 3 of the License, or
 (at your option) any later version.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this program.  If not, see <http://www.gnu.org/licenses/>.
]]--


function get_param(var)
  -- Get the variables posted to script
  params=" "..string.gsub(os.getenv("QUERY_STRING"),"&"," ").." "
  local p=string.gsub(params,".*"..var.."=(.-)%s.*","%1")
  -- strip any naughty leading path
  p=string.gsub(p,".*/","")
  return(p)
end


function open_serial () 
  -- Open the serial port and return the fd
  cmd_status = os.execute ("stty -F /dev/ttyUSB1 raw speed 4800 > /dev/null") 
  serfd = assert(io.open('/dev/ttyUSB0',"w"), "[Status] Error opening serial port!")
  return serfd
end


--
-- Main part
--

-- Start printing the headers
print ("Content-Type: text/html\n\n")


-- Get the variables from the form
my_device = get_param("device")
my_cmd = get_param ("cmd")


-- Check if we got some data first
if my_device == nil or my_cmd == nil then
  print ("ERR")
end


-- Open the serial port and send the data
my_serial = open_serial()
my_serial:write (my_device .. "\n" .. my_cmd .. "\n" )
my_serial:flush()
my_serial:close()


-- Send out some info
print ("OK")


-- Update the status
-- Write out a file (plugX.txt) with the value 1 or 0
my_file = io.open('/home/www/data/plug' .. my_device .. '.txt', 'w')
my_file:write (my_cmd)
my_file:flush()
my_file:close()

